# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: clock.tcl,v 1.8 2003/02/09 16:31:28 matthieu Exp $
#
# Affichage d'une horloge
#
#----------------------------------------------------------------------
package provide Gdhe::models 1.0

proc h2Clock {} {
    
    cullFace True
    pushMatrix
    object Cadran {
	color 100 100 101
	box 0 -0.025 -0.5 1 0.05 1
	# cylinder 0 -0.1 0 y 1.0 0.1
	color 160 160 100
	for { set i 0 } { $i < 12 } { incr i } {
	    box 0 0 0.4 0.04 0.02 0.08
	    rotate 30 0 1 0
	}
    }
    set c [clock seconds]
    regsub {^0} [clock format $c -format %I] {} h
    regsub {^0} [clock format $c -format %M] {} m
    regsub {^0} [clock format $c -format %S] {} s
    # puts "$h:$m:$s"

    # Petite aiguille
    pushMatrix
    color 130 0 0
    rotate [expr  $h * 30 + ( $m / 2 )] 0 -1 0
    box 0 0.02 -0.05 0.03 0.02 0.3
    popMatrix
    # Grande aiguille
    pushMatrix
    rotate [expr $m*6] 0 -1 0
    box 0 0.02 -0.05 0.03 0.02 0.45
    popMatrix
    # Secondes
    color 130 130 0
    pushMatrix
    rotate [expr $s*6] 0 -1 0
    box 0 0.03 -0.05 0.015 0.01 0.45
    popMatrix

    popMatrix
    after 1000 redrawAllWindows
}
